module receive_tb;
reg        rst;
reg        clk;
reg        drx;
wire       rx;
reg        fs;
reg  [7:0] txdata, rxdata, data, pass;

initial begin
  $dumpfile ("receive_tb.vcd");
  $dumpvars (1, my_receive);

  pass = 0;

  fs  = 0;
  rst = 1;
  drx = 0;

  // reset pulse

  clk = 1;
  #1 clk = 0;
  #1 clk = 1;
  rst = 0;
  #1 clk = 0;
  #1 clk = 1;

  // Send an 8 bit TDM word

  txdata = 8'b11010010;
  data = txdata;
  fs = 1;
  drx = data[7];
  #1  clk = 0;  
  #1  clk = 1;
  fs = 0;
  repeat (7) begin
    data = { data[6:0], 1'b0 };
    drx = data[7];
    #1  clk = 0;  
    #1  clk = 1;
  end

  //----- Clock out 10 bit RS232 Word ----------------*/

  repeat (10) begin
    repeat (18) begin 
      #1  clk = 0;  
      #1  clk = 1;
    end
  end

  // few more clocks for good luck

  repeat (18) begin 
    #1  clk = 1;
    #1  clk = 0;  
  end

end

receive my_receive(
.rst      (rst),
.clk      (clk),
.drx      (drx),
.fs       (fs),
.rx       (rx)
);

endmodule

